%global cri_o_min 1.14
%global cri_o_max 1.18
%global kata_runtime_version 1.7.3-1.0.5%{dist}
%global kata_proxy_version 1.7.3-1.0.4%{dist}
%global kata_shim_version 1.7.3-1.0.4%{dist}
%global kata_throttler_version 1.7.3-1.0.4%{dist}
%global kata_image_version 1.7.3-1.0.5.1.ol7_202007011859
%global kernel_uek_container_version 4.14.35-1902.303.5.3%{dist}
%global kernel_uek_min 4.14
%global kernel_uek_max 4.15
%global cri_tools_min 1.14
%global cri_tools_max 1.18
%global qemu_min 15:3.1
%global qemu_max 15:4.0

Name:      kata
Version:   1.7.3
Release:   1.0.7%{?dist}
Vendor:    Oracle America
Summary:   meta rpm to ease cri-o and kata installation for olcne
Group:     Development/Tools
License:   UPL

Requires: cri-o >= %{cri_o_min}
Requires: cri-o < %{cri_o_max}
Requires: kata-runtime = %{kata_runtime_version}
Requires: kata-proxy = %{kata_proxy_version}
Requires: kata-shim = %{kata_shim_version}
Requires: kata-ksm-throttler = %{kata_throttler_version}
Requires: kata-image = %{kata_image_version}
Requires: kernel-uek-container = %{kernel_uek_container_version}
Requires: kernel-uek >= %{kernel_uek_min}
Requires: kernel-uek < %{kernel_uek_max}
Requires: cri-tools >= %{cri_tools_min}
Requires: cri-tools < %{cri_tools_max}
Requires: qemu >= %{qemu_min}
Requires: qemu < %{qemu_max}

%description
A meta rpm to help facilitate the installation of cri-o and kata related components.

%prep

%install

%files

%doc

%post
# we need to make some baseline adjustments to the crio config post installation
checkCrioConf () {
  # arg1 config section, arg2 keyword, arg3 value
  # if keyword is missing, add it and value to config section
  if ! grep -q "^$2" %{_sysconfdir}/crio/crio.conf; then
    sed -i \
        -e "/^$1/a $2 = $3" \
        %{_sysconfdir}/crio/crio.conf
  else
  # keyword is present, ensure it has the correct value
    sed -i \
        -e "s/^$2.*/$2 = $3/" \
        %{_sysconfdir}/crio/crio.conf
  fi
}

checkCrioConf "\[crio.runtime\]" "manage_network_ns_lifecycle" "true"
checkCrioConf "\[crio.runtime\]" "selinux" "false"
checkCrioConf "\[crio.image\]" "registries" "\[\"docker.io\", \"container-registry.oracle.com\"\]"
checkCrioConf "\[crio.image\]" "pause_image_auth_file" "\"\/run\/containers\/0\/auth.json\""
checkCrioConf "\[crio.image\]" "pause_image " "\"container-registry.oracle.com\/kubernetes\/pause:3.1\""

# insert extra config section if it's missing
if ! grep -q "\[crio.runtime.runtimes.kata\]" %{_sysconfdir}/crio/crio.conf; then
  sed -i \
      -e '/\[crio.runtime.runtimes.runc\]/i\
\[crio.runtime.runtimes.kata\]\
runtime_path = \"\/usr\/bin\/kata-runtime\"\
runtime_type = \"oci\"\n'\
      %{_sysconfdir}/crio/crio.conf
fi

%changelog
* Wed Jun 24 2020 Daniel Krasinski <daniel.krasinski@oracle.com> - 1.7.3-1.0.7
- Address CVE-2020-2023
- Address CVE-2020-2024
- Address CVE-2020-2025
- Address CVE-2020-2026

* Tue Jan 14 2020 Tom Cocozzello <tom.cocozzello@oracle.com> - 1.7.3-1.0.6
- Support a wider range of cri versions

* Fri Sep 06 2019 Durai Govindasamy <durai.vattakalvalasu.govindas@oracle.com> - 1.7.3-1.0.5
- modified the package description, removed source, license file

* Thu Aug 29 2019 Durai Govindasamy <durai.vattakalvalasu.govindas@oracle.com> - 1.7.3-1.0.4
- included the license file

* Thu Aug 22 2019 Michael Calunod <michael.calunod@oracle.com> - 1.7.3-1.0.3
- Removed URL, Source, modified license type

* Mon Aug 19 2019 Michael Calunod <michael.calunod@oracle.com> - 1.7.3-1.0.2
- Added URL

* Mon Jul 22 2019 James McCarthy <james.m.mccarthy@oracle.com> - 1.7.3-1.0.1
- Initial version of the package
